<script setup>
import Map from "./components/Map.vue";
import Status from "./components/Status.vue";
import Score from "./components/Score.vue";
import sousprefs from "../public/sous_prefs.json";
import { ref } from "vue";

const maxtries = ref(10);
const maxrounds = ref(Math.min(10, sousprefs.length));
const rands = getDistinctRandNbrs(maxrounds.value)
 
const fails = ref(0);
const state = ref("departement");
const distance = ref(NaN);
const score = ref(0);
const maxscore = ref(0);
const round = ref(1);
const souspref = sousprefs[rands[0]];
const lng = ref(souspref.coord[0]);
const lat = ref(souspref.coord[1]);
const code = ref(souspref.code);
const name = ref(souspref.communeLabel);
const map = ref(null);

 function getDistinctRandNbrs(nbr) {
   const randNumbers = new Set();
   while (randNumbers.size < nbr) {
     randNumbers.add(Math.floor(Math.random() * sousprefs.length));
   }
   return Array.from(randNumbers);
 }

function setDistance(dist) {
  distance.value = dist;
  const depScore = Math.max(maxtries.value - fails.value, 0) * 10;
  const distScore = Math.max(100 - Math.max(dist / 1000 - 5, 0) * 2, 0);
  const roundScore = depScore + Math.floor(distScore);
  score.value += roundScore;
  maxscore.value += 200;

  if (round.value >= maxrounds.value) {
    state.value = "game over";
  } else {
    state.value = "finished";
  }
}

function nextRound() {
  if (round.value >= maxrounds.value) {
    state.value = "game over";
  } else {
    map.value.reset();
    const souspref = sousprefs[rands[round.value]];
    round.value++;
    lng.value = souspref.coord[0];
    lat.value = souspref.coord[1];
    code.value = souspref.code;
    name.value = souspref.communeLabel;

    state.value = "departement";
    fails.value = 0;
  }
}

function failedDep() {
  fails.value++;

  if (fails.value >= maxtries.value) {
    map.value.reset();
    nextRound();
  }
}
</script>

<template>
  <div class="h-screen">
    <div class="h-1/6">
      <h3 class="text-xl font-bold">Tuturoquizz</h3>
      <h4 class="text-lg font-thin">fun with sous-préfectures</h4>
      <Status
        :name="name"
        :state="state"
        :fails="fails"
        :maxtries="maxtries"
        :distance="distance"
        @next="nextRound"
      />
      <Score
        :score="score"
        :round="round"
        :maxrounds="maxrounds"
        :maxscore="maxscore"
      />
    </div>
    <Map
      class="h-5/6"
      ref="map"
      :lng="lng"
      :lat="lat"
      :code="code"
      @fail="failedDep"
      @success="state = 'souspref'"
      @distance="setDistance"
      :state="state"
    />
  </div>
</template>

<style scoped>
@import "maplibre-gl/dist/maplibre-gl.css";
</style>
